#ifndef DEVICE_H_INCLUDED
#define DEVICE_H_INCLUDED

//Infrared sensor
#define IR (1<<PB0)
//Display Latch Enable
#define LE (1<<PB1)
#define LE_LOW (PORTB &= ~LE)
#define LE_HI  (PORTB |= LE)
//Buttons
#define SW1 (1<<PB2)
#define SW2 (1<<PB3)
#define SW3 (1<<PB4)
#define SW4 (1<<PB5)
#define BUTTON_RAW_STATE (~PINB)&(SW1|SW2|SW3|SW4)
//Display Column 2
#define A2 (1<<PC0)
#define A2_ON (PORTC &= ~A2)
//Display Column 1
#define A1 (1<<PC1)
#define A1_ON (PORTC &= ~A1)
//Light Sensor (photo resistor)
#define PH (1<<PC2)
//Display Column 3
#define A3 (1<<PC3)
#define A3_ON (PORTC &= ~A3)
//Display Column 4
#define A4 (1<<PC4)
#define A4_ON (PORTC &= ~A4)
//Display Column 5
#define A5 (1<<PC5)
#define A5_ON (PORTC &= ~A5)
#define A1_A2_A3_A4_A5_OFF (PORTC |= (A1|A2|A3|A4|A5))
//USART
#define RXD (1<<PD0)
#define TXD (1<<PD1)
//Sound Generator
#define BUZZER (1<<PD2)
#define BUZZER_ON (PORTD |= BUZZER)
#define BUZZER_OFF (PORTD &= ~BUZZER)
//Device Power Sensor
#define PWR (1<<PD3)
#define POWER_ON (PIND & PWR)
#define POWER_OFF !(PIND & PWR)
//Front Panel LED
#define LED (1<<PD4)
#define LED_ON (PORTD |= LED)
#define LED_OFF (PORTD &= ~LED)
#define LED_TOGGLE (PORTD ^= LED)
//Display Output Enable
#define OE (1<<PD5)
#define OE_LOW (PORTD &= ~OE)
#define OE_HI (PORTD |= OE)
//Display Clock
#define CLK (1<<PD6)
#define CLK_LOW (PORTD &= ~CLK)
#define CLK_HI  (PORTD |= CLK)
//Display Serial Data Input
#define SDI  (1<<PD7)
#define SDI_LOW (PORTD &= ~SDI)
#define SDI_HI  (PORTD |= SDI)

void DEVICE_Init(void);
void DEVICE_Sleep(void);
void DEVICE_Wakeup(void);

#endif // CONFIG_H_INCLUDED
