#include <avr/io.h>
#include <avr/interrupt.h>
#include "ATmega88PA.h"
#include "osc.h"

#define XTAL 32768UL
#define TARGET (F_CPU*100)/XTAL

void OSC_Calibrate(void) {
    TIMER1_NORMAL_MODE;
    TIMER1_CLOCK_PRESCALER_1_START;
    TIMER2_NORMAL_MODE;
    TIMER2_ASYNCHRONOUS_CLOCK_INPUT;
    TIMER2_CLEAR_OVERFLOW_INTERRUPT_FLAG;
    CLOCK_CALIBRATION_VALUE(0x3F);
    //wait for asynchronous timer to stabilize
    TIMER2_CLOCK_PRESCALER_64_START;
    while(!TIMER2_OVERFLOW) {}
    TIMER2_CLOCK_PRESCALER_1_START;

    uint8_t step = 0x1F;
    while(step) {
        TIMER2_RESET;
        while(TIMER2_ASYNC_UPDATE) {}
        TIMER1_RESET;
        while(TIMER2_VALUE < 100) {}
        TIMER1_CLOCK_PRESCALER_0_STOP;
        if(TIMER1_VALUE < TARGET) {
            CLOCK_INCR_CALIBRATION_VALUE(step);
        }
        if(TIMER1_VALUE > TARGET) {
            CLOCK_DECR_CALIBRATION_VALUE(step);
        }
        step >>= 1;
        TIMER1_CLOCK_PRESCALER_1_START;
    }
    TIMER1_CLOCK_PRESCALER_0_STOP;
    TIMER2_CLOCK_PRESCALER_0_STOP;
}
